# [react-native-animated-splash](https://www.npmjs.com/package/react-native-animated-splash)
[![Build Status](https://travis-ci.org/joemccann/dillinger.svg?branch=master)](https://travis-ci.org/joemccann/dillinger)
![Supports Android and iOS](https://img.shields.io/badge/platforms-android%20|%20ios-lightgrey.svg?style=flat-square)
[![License](http://img.shields.io/:license-mit-blue.svg?style=flat-square)](http://badges.mit-license.org)
[![NPM](https://img.shields.io/npm/dm/react-native-animated-splash)](https://www.npmjs.com/package/react-native-animated-splash)
[![Version](https://img.shields.io/npm/v/react-native-animated-splash)](https://www.npmjs.com/package/react-native-animated-splash)


React-Native-Animated-Splash is developed to help the react-native developers in speeding-up their development process. This package leverages the developer in implementing native animations by using our builtin classes for animation with easy to use api, all the animations run on native thread for smooth performance.
##### Objective
The main objective or the edge of this module is that, splash animation runs in parallel with loading of javascript, which means when animation is running, javascript is being loaded in parallel behind the scenes, moreover componentDidMount can also be called for any api hits before calling hide function of splash from react-native side.

### For iOS and Android

### Installation
If you prefer **npm**,
```sh
$ npm install react-native-animated-splash --save
```

If you prefer **yarn**,
```sh
$ yarn add react-native-animated-splash
```
#### For Ios bump deployment version to 12.0+ in Xcode and podfile

```sh
platform :ios, '12.0'
```

#### Also add this line in your podfile

```sh
pod 'RNAnimatedSplash', :path => '../node_modules/react-native-animated-splash'
```

#### Android Usage with Method Descriptions [Here](https://github.com/Blitz-Mobile-Apps/react-native-animated-splash/blob/v2/androidDescription.md)
###  Android Examples
#### Check Android Example Code [Here](https://github.com/Blitz-Mobile-Apps/react-native-animated-splash/blob/v2/androidexample.md)
![](https://github.com/Blitz-Mobile-Apps/react-native-animated-splash/blob/master/example1.gif?raw=true)
![](https://github.com/Blitz-Mobile-Apps/react-native-animated-splash/blob/master/example2.gif?raw=true)
>
>
#### iOS Usage with Method Descriptions [Here](https://github.com/Blitz-Mobile-Apps/react-native-animated-splash/blob/v2/iosDescription.md)
###  Ios Examples
#### Check iOS Example Code [Here](https://github.com/Blitz-Mobile-Apps/react-native-animated-splash/blob/v2/iosexample.md)
![](https://github.com/Blitz-Mobile-Apps/react-native-animated-splash/blob/master/example1ios.gif?raw=true)
![](https://github.com/Blitz-Mobile-Apps/react-native-animated-splash/blob/master/example2ios.gif?raw=true)

 


License
MIT 
